<template>
  <info-card title="Información general del envío">
    <v-col sm="12" lg="4" xl="4" cols="12">
      <date-picker
        v-model="departureDate"
        label="Fecha de salida"
      />
      <time-picker
        v-model="departureTime"
        :restricted-to="departureDate"
        label="Hora de salida"
      />
      <v-text-field
        :value="minVehicles"
        label="Vehículos mínimos necesarios"
        :hint="`La capacidad de cada vehículo es de ${vehicleCapacity} unidades (pallets)`"
        outlined
        readonly
        persistent-hint
      />
    </v-col>
  </info-card>
</template>

<script>
import { mapState } from 'vuex';
import { add, format, startOfToday } from 'date-fns';
import InfoCard from '~/components/Common/Info/InfoCard';
import DatePicker from '~/components/Common/Form/DatePicker';
import TimePicker from '~/components/Common/Form/TimePicker';

export default {
  name: 'GeneralInfo',
  components: {
    InfoCard,
    DatePicker,
    TimePicker,
  },
  props: {
    minVehicles: {
      type: Number,
      default: 0,
    },
  },
  emits: ['change'],
  data() {
    const time = format(add(new Date(), { hours: 1 }), 'HH:00');
    const [hours, minutes] = time.split(':');

    return {
      departureDate: startOfToday(),
      departureTime: { hours, minutes },
    };
  },
  computed: {
    ...mapState({
      vehicleCapacity: state => state.config.capacity,
    }),
    departureAt() {
      return add(this.departureDate, this.departureTime);
    },
  },
  watch: {
    departureAt() {
      this.$emit('change', { departureAt: this.departureAt });
    },
  },
};
</script>
